Clazz.declarePackage ("jalview.analysis.scoremodels");
Clazz.load (["jalview.api.analysis.ScoreModelI"], "jalview.analysis.scoremodels.PairwiseSeqScoreModel", ["jalview.util.Comparison"], function () {
c$ = Clazz.declareType (jalview.analysis.scoremodels, "PairwiseSeqScoreModel", null, jalview.api.analysis.ScoreModelI);
Clazz.overrideMethod (c$, "findDistances", 
function (seqData) {
var sequenceString = seqData.getSequenceStrings (jalview.util.Comparison.GapChars.charAt (0));
var noseqs = sequenceString.length;
var distance =  Clazz.newFloatArray (noseqs, noseqs, 0);
var maxscore = 0;
var end = sequenceString[0].length;
for (var i = 0; i < (noseqs - 1); i++) {
for (var j = i; j < noseqs; j++) {
var score = 0;
for (var k = 0; k < end; k++) {
try {
score += this.getPairwiseScore (sequenceString[i].charAt (k), sequenceString[j].charAt (k));
} catch (ex) {
if (Clazz.exceptionOf (ex, Exception)) {
System.err.println ("err creating " + this.getName () + " tree");
ex.printStackTrace ();
} else {
throw ex;
}
}
}
distance[i][j] = score;
if (score > maxscore) {
maxscore = score;
}}
}
for (var i = 0; i < (noseqs - 1); i++) {
for (var j = i; j < noseqs; j++) {
distance[i][j] = maxscore - distance[i][j];
distance[j][i] = distance[i][j];
}
}
return distance;
}, "jalview.datamodel.AlignmentView");
});
