Clazz.declarePackage ("jalview.commands");
Clazz.load (["jalview.commands.EditCommand"], "jalview.commands.RemoveGapsCommand", ["jalview.util.Comparison"], function () {
c$ = Clazz.declareType (jalview.commands, "RemoveGapsCommand", jalview.commands.EditCommand);
Clazz.makeConstructor (c$, 
function (description, seqs, al) {
Clazz.superConstructor (this, jalview.commands.RemoveGapsCommand, []);
this.description = description;
var width = 0;
for (var i = 0; i < seqs.length; i++) {
if (seqs[i].getLength () > width) {
width = seqs[i].getLength ();
}}
this.findGaps (seqs, 0, width, al);
}, "~S,~A,jalview.datamodel.AlignmentI");
Clazz.makeConstructor (c$, 
function (description, seqs, start, end, al) {
Clazz.superConstructor (this, jalview.commands.RemoveGapsCommand, []);
this.description = description;
this.findGaps (seqs, start, end, al);
}, "~S,~A,~N,~N,jalview.datamodel.AlignmentI");
Clazz.defineMethod (c$, "findGaps", 
function (seqs, start, end, al) {
var startCol = -1;
var endCol = -1;
var deletedCols = 0;
var j;
var jSize;
this.clearEdits ();
var $delete = true;
var sequence;
for (var s = 0; s < seqs.length; s++) {
deletedCols = 0;
startCol = -1;
endCol = -1;
sequence = seqs[s].getSequence (start, end + 1);
jSize = sequence.length;
for (j = 0; j < jSize; j++) {
$delete = true;
if (!jalview.util.Comparison.isGap (sequence[j])) {
if ($delete) {
endCol = j;
}$delete = false;
}if ($delete && startCol == -1) {
startCol = j;
}if (!$delete && startCol > -1) {
this.appendEdit (jalview.commands.EditCommand.Action.DELETE_GAP,  Clazz.newArray (-1, [seqs[s]]), start + startCol - deletedCols, endCol - startCol, al, false, null);
deletedCols += (endCol - startCol);
startCol = -1;
endCol = -1;
}}
if ($delete && startCol > -1) {
this.appendEdit (jalview.commands.EditCommand.Action.DELETE_GAP,  Clazz.newArray (-1, [seqs[s]]), start + startCol - deletedCols, jSize - startCol, al, false, null);
}}
this.performEdit (0, null);
}, "~A,~N,~N,jalview.datamodel.AlignmentI");
});
